<template>
  <component
    :is="earComponent"
    v-if="earComponent"
    :color="props.color"
    :sub-color="subColor"
  />
</template>

<script lang="ts" setup>
import { computed } from 'vue'

import Crew from './Crew.vue'
import Tee from './Tee.vue'
import Polo from './Polo.vue'
import chroma from 'chroma-js'
import { ShirtType } from '@/api'

const props = defineProps<{
  color: string
  type: ShirtType
}>()

const earComponent = computed(() => {
  switch (props.type) {
    case 'crew':
      return Crew
    case 'tee':
      return Tee
    case 'polo':
    default:
      return Polo
  }
})

const BRIGHTEN_DEGREE = 2

const subColor = computed(() =>
  chroma(props.color as string)
    .brighten(BRIGHTEN_DEGREE)
    .hex()
)
</script>
